#pragma once

#include "CGAL_Object.h"
#include <list>


class PolygonSet : public CGAL_Object
{
public:
	PolygonSet(void);
	~PolygonSet(void);

	virtual void Draw();
	virtual void BuildDisplayListObject();
	virtual void Clear();
	virtual void ComputeGeometryParameters();

	void SetShowPolygons(bool b);

public:
	std::list<std::list<Point_2>>	m_polygons; 

	bool							m_bShowPolygons;

	BBox_2							m_bbox;;
	Point_2							m_center;
	float							m_fFitScale;
};
