// SegmentationView.cpp : CSegmentationView ʵ
//

#include "stdafx.h"
#include "Segmentation.h"
#include "SegmentationView.h"
#include "SegmentationDoc.h"
#include "OperationView.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSegmentationView

IMPLEMENT_DYNCREATE(CSegmentationView, COpenGLView)

BEGIN_MESSAGE_MAP(CSegmentationView, COpenGLView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &COpenGLView::OnFilePrintPreview)
	ON_COMMAND(ID_VIEW_SOLID, OnViewModelSolid)
	ON_COMMAND(ID_VIEW_WIREFRAME, OnViewModelWireFrame)
	ON_COMMAND(ID_VIEW_POINTS, OnViewModelPoints)
	ON_COMMAND(ID_VIEW_FITWINDOW, OnViewFitWindow)
	ON_COMMAND(ID_VIEW_AXISES, OnViewAxises)
	ON_COMMAND(ID_VIEW_BACKGROUND_COLOR, OnViewBackgroundColor)
	ON_COMMAND(ID_VIEW_BACK, OnViewPosBack)
	ON_COMMAND(ID_VIEW_BOTTOM, OnViewPosBottom)
	ON_COMMAND(ID_VIEW_FRONT, OnViewPosFront)
	ON_COMMAND(ID_VIEW_LEFT, OnViewPosLeft)
	ON_COMMAND(ID_VIEW_RIGHT, OnViewPosRight)
	ON_COMMAND(ID_VIEW_TOP, OnViewPosTop)
	ON_COMMAND(ID_VIEW_TRIMETRIC, OnViewPosTrimetric)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SOLID, OnUpdateViewSolid)
	ON_UPDATE_COMMAND_UI(ID_VIEW_POINTS, OnUpdateViewPoints)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WIREFRAME, OnUpdateViewWireframe)
	ON_UPDATE_COMMAND_UI(ID_VIEW_AXISES, OnUpdateViewAxises)
END_MESSAGE_MAP()

// CSegmentationView /

CSegmentationView::CSegmentationView()
{
	// TODO: ڴ˴ӹ
}


CSegmentationView::~CSegmentationView()
{
}

BOOL CSegmentationView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return COpenGLView::PreCreateWindow(cs);
}

// CSegmentationView 

void CSegmentationView::OnDraw(CDC* pDC)
{
	CSegmentationDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ

	COpenGLView::OnDraw(pDC);
}


// CSegmentationView ӡ

BOOL CSegmentationView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CSegmentationView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CSegmentationView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CSegmentationView 

#ifdef _DEBUG
void CSegmentationView::AssertValid() const
{
	COpenGLView::AssertValid();
}

void CSegmentationView::Dump(CDumpContext& dc) const
{
	COpenGLView::Dump(dc);
}

CSegmentationDoc* CSegmentationView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSegmentationDoc)));
	return (CSegmentationDoc*)m_pDocument;
}
#endif //_DEBUG


// CSegmentationView Ϣ


void CSegmentationView::OnViewModelSolid() 
{
	// TODO: Add your command handler code here	
	m_nDisplayMode = GL_FILL;
	RedrawWindow();
}


void CSegmentationView::OnViewModelWireFrame() 
{
	// TODO: Add your command handler code here
	m_nDisplayMode = GL_LINE;
	RedrawWindow();
}


void CSegmentationView::OnViewModelPoints() 
{
	// TODO: Add your command handler code here	
	m_nDisplayMode = GL_POINT;
	RedrawWindow();
}


void CSegmentationView::OnViewFitWindow() 
{
	// TODO: Add your command handler code here
	ViewFitAll();
}


void CSegmentationView::OnViewPosBack() 
{
	ViewPosBack();
}


void CSegmentationView::OnViewPosBottom() 
{
	ViewPosBottom();
}


void CSegmentationView::OnViewPosFront() 
{
	ViewPosFront();
}


void CSegmentationView::OnViewPosLeft() 
{
	ViewPosLeft();
}


void CSegmentationView::OnViewPosRight() 
{
	ViewPosRight();
}


void CSegmentationView::OnViewPosTop() 
{
	ViewPosTop();
}


void CSegmentationView::OnViewPosTrimetric() 
{
	ViewPosTrimetric();
}


void CSegmentationView::OnViewLight() 
{
	m_bEnableLight = !m_bEnableLight;
	EnableLighting(m_bEnableLight);
}

void CSegmentationView::OnViewAxises()
{
	// TODO: Add your command handler code here
	m_bShowAxises = !m_bShowAxises;
	EnableShowAxises(m_bShowAxises);
}

void CSegmentationView::OnViewBackgroundColor()
{
	CColorDialog dlg;
	dlg.m_cc.Flags |= CC_FULLOPEN;
	if(dlg.DoModal() == IDOK)
	{
		COLORREF c = dlg.GetColor();
		m_BackColorRed	 = GetRValue(c) / 255.0f;
		m_BackColorGreen = GetGValue(c) / 255.0f;
		m_BackColorBlue  = GetBValue(c) / 255.0f;

		glClearColor(m_BackColorRed, m_BackColorGreen, m_BackColorBlue, 1.0f);
		InvalidateRect(NULL);	
	}
}


void CSegmentationView::OnUpdateViewAxises(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bShowAxises ? 1 : 0);
}

void CSegmentationView::OnUpdateViewLight(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bEnableLight ? 1 : 0);	
}


void CSegmentationView::OnUpdateViewPoints(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nDisplayMode == GL_POINT ? 1 : 0);	
}

void CSegmentationView::OnUpdateViewWireframe(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nDisplayMode == GL_LINE ? 1 : 0);	
}

void CSegmentationView::OnUpdateViewSolid(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nDisplayMode == GL_FILL ? 1 : 0);	
}


void CSegmentationView::RenderSceneScalable()
{	
	CSegmentationDoc* pDoc = GetDocument();

	glPolygonMode(GL_FRONT_AND_BACK, m_nDisplayMode);

	TriMesh* pMesh = pDoc->m_pTriMesh;
	if (pMesh != NULL) 
	{
		pMesh->DrawModel();
		pMesh->DrawFeatureEdges();
		pDoc->m_segmentation.Draw();
	}

	pDoc->m_polygonSet.Draw();
	pDoc->m_straightSkeleton.Draw();
	pDoc->m_polygonDelaunayGraph.Draw();
}


void CSegmentationView::OnInitialUpdate()
{
	COpenGLView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	m_pOperationView = ((CMainFrame*)AfxGetMainWnd())->m_pOperationView;
}

