// SegmentationView.h : CSegmentationView Ľӿ
//


#pragma once

#include "OpenGLView.h"

class COperationView;
class CSegmentationDoc;

class CSegmentationView : public COpenGLView
{
protected: // л
	CSegmentationView();
	DECLARE_DYNCREATE(CSegmentationView)

// 
public:
	CSegmentationDoc* GetDocument() const;

// 
public:
	virtual void RenderSceneScalable();

public:
	COperationView*	    m_pOperationView;

// д
public:
	virtual void OnDraw(CDC* pDC);  // дԻƸͼ
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnInitialUpdate();

// ʵ
public:
	virtual ~CSegmentationView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg void OnViewModelSolid();
	afx_msg void OnViewModelPoints();
	afx_msg void OnViewModelWireFrame();
	afx_msg void OnViewFitWindow();
	afx_msg void OnViewLight();
	afx_msg void OnViewBackgroundColor();
	afx_msg void OnViewAxises();
	afx_msg void OnUpdateViewSolid(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPoints(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewWireframe(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewLight(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewAxises(CCmdUI *pCmdUI);
	afx_msg void OnViewPosBack();
	afx_msg void OnViewPosBottom();
	afx_msg void OnViewPosFront();
	afx_msg void OnViewPosLeft();
	afx_msg void OnViewPosRight();
	afx_msg void OnViewPosTop();
	afx_msg void OnViewPosTrimetric();
};

#ifndef _DEBUG  // SegmentationView.cpp еĵ԰汾
inline CSegmentationDoc* CSegmentationView::GetDocument() const
   { return reinterpret_cast<CSegmentationDoc*>(m_pDocument); }
#endif

