
/*
* Copyright (c) 2007, Shenyang Institute of Automation, Chinese Academy
* of Sciences. , all rights reserved.
* 
* Filename     : Constant.h
* Project	   : xMesh library
* Abstract     : Declaration of constant variables
* Version      : 1.0
* Author			: , nanlliang@sia.cn
* Original Author   : , nanlliang@sia.cn
* Accomplished date : Dec. 29, 2007
*/

//-----------------------------------------------------------------

#pragma once;


#ifndef  FLOAT_PI
# define FLOAT_PI  3.1415926f
#endif

#ifndef  DOUBLE_PI
# define DOUBLE_PI  3.141592653589793
#endif

#ifndef  FLOAT_MAX 
#define  FLOAT_MAX  1.7976931348623157E+38
#endif

#ifndef  DOUBLE_MAX
# define DOUBLE_MAX 1.7976931348623157E+308    /* max decimal value of a "double"*/
#endif


#ifndef CAD_ZERO
#define CAD_ZERO    1E-10
#endif